diff -ruN vdr-2.3.8/ci.c vdr-2.3.9/ci.c
--- vdr-2.3.8/ci.c	2017-06-19 14:13:38.000000000 +0200
+++ vdr-2.3.9/ci.c	2018-02-03 13:55:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.c 4.18 2017/06/19 12:13:38 kls Exp $
+ * $Id: ci.c 4.20 2018/02/03 12:55:03 kls Exp $
  */
 
 #include "ci.h"
@@ -122,6 +122,8 @@
   uchar *bufp;
   uchar mtdCatBuffer[TS_SIZE]; // TODO: handle multi packet CATs!
   int length;
+  cMutex mutex;
+  bool handlingPid;
   void AddEmmPid(int Pid);
   void DelEmmPids(void);
 public:
@@ -130,6 +132,15 @@
   virtual void Receive(const uchar *Data, int Length);
   bool HasCaPids(void) const { return NumPids() - emmPids.Size() - 1 > 0; }
   void Reset(void) { DelEmmPids(); catVersion = -1; }
+  bool HandlingPid(void);
+       ///< The cCaPidReceiver adds/deletes PIDs to/from the base class cReceiver,
+       ///< which in turn does the same on the cDevice it is attached to. The cDevice
+       ///< then sets the PIDs on the assigned cCamSlot, which can cause a deadlock on the
+       ///< cCamSlot's mutex if a cReceiver is detached from the device at the same time.
+       ///< Since these PIDs, however, are none that have to be decrypted,
+       ///< it is not necessary to set them in the CAM. Therefore this function is
+       ///< used in cCamSlot::SetPid() to detect this situation, and thus avoid the
+       ///< deadlock.
   };
 
 cCaPidReceiver::cCaPidReceiver(void)
@@ -137,7 +148,11 @@
   catVersion = -1;
   bufp = NULL;
   length = 0;
+  handlingPid = false;
+  cMutexLock MutexLock(&mutex);
+  handlingPid = true;
   AddPid(CATPID);
+  handlingPid = false;
 }
 
 void cCaPidReceiver::AddEmmPid(int Pid)
@@ -147,14 +162,20 @@
          return;
       }
   emmPids.Append(Pid);
+  cMutexLock MutexLock(&mutex);
+  handlingPid = true;
   AddPid(Pid);
+  handlingPid = false;
 }
 
 void cCaPidReceiver::DelEmmPids(void)
 {
+  cMutexLock MutexLock(&mutex);
+  handlingPid = true;
   for (int i = 0; i < emmPids.Size(); i++)
       DelPid(emmPids[i]);
   emmPids.Clear();
+  handlingPid = false;
 }
 
 void cCaPidReceiver::Receive(const uchar *Data, int Length)
@@ -239,6 +260,12 @@
      }
 }
 
+bool cCaPidReceiver::HandlingPid(void)
+{
+  cMutexLock MutexLock(&mutex);
+  return handlingPid;
+}
+
 // --- cCaActivationReceiver -------------------------------------------------
 
 // A receiver that is used to make the device stay on a given channel and
@@ -279,7 +306,7 @@
      if (TsIsScrambled(Data))
         lastScrambledTime = Now;
      else if (Now - lastScrambledTime > UNSCRAMBLE_TIME) {
-        dsyslog("CAM %d: activated!", camSlot->SlotNumber());
+        dsyslog("CAM %d: activated!", camSlot->MasterSlotNumber());
         Skins.QueueMessage(mtInfo, tr("CAM activated!"));
         cDevice *d = Device();
         Detach();
@@ -1111,10 +1138,12 @@
        case AOT_CA_PMT_REPLY: {
             dbgprotocol("Slot %d: <== Ca Pmt Reply (%d)", CamSlot()->SlotNumber(), SessionId());
             if (!repliesToQuery) {
-               dsyslog("CAM %d: replies to QUERY - multi channel decryption (MCD) possible", CamSlot()->SlotNumber());
+               if (CamSlot()->IsMasterSlot())
+                  dsyslog("CAM %d: replies to QUERY - multi channel decryption (MCD) possible", CamSlot()->SlotNumber());
                repliesToQuery = true;
                if (CamSlot()->MtdAvailable()) {
-                  dsyslog("CAM %d: supports multi transponder decryption (MTD)", CamSlot()->SlotNumber());
+                  if (CamSlot()->IsMasterSlot())
+                     dsyslog("CAM %d: supports multi transponder decryption (MTD)", CamSlot()->SlotNumber());
                   CamSlot()->MtdActivate(true);
                   }
                }
@@ -2588,6 +2617,8 @@
 
 void cCamSlot::SetPid(int Pid, bool Active)
 {
+  if (caPidReceiver && caPidReceiver->HandlingPid())
+     return;
   cMutexLock MutexLock(&mutex);
   for (cCiCaProgramData *p = caProgramList.First(); p; p = caProgramList.Next(p)) {
       for (cCiCaPidData *q = p->pidList.First(); q; q = p->pidList.Next(q)) {
diff -ruN vdr-2.3.8/ci.h vdr-2.3.9/ci.h
--- vdr-2.3.8/ci.h	2017-06-09 16:21:26.000000000 +0200
+++ vdr-2.3.9/ci.h	2018-03-17 13:17:37.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.h 4.10 2017/06/09 14:21:26 kls Exp $
+ * $Id: ci.h 4.12 2018/03/17 12:17:37 kls Exp $
  */
 
 #ifndef __CI_H
@@ -304,7 +304,7 @@
   virtual ~cCamSlot();
   bool IsMasterSlot(void) { return !masterSlot; }
        ///< Returns true if this CAM slot itself is a master slot (which means that
-       ///< it doesn't have pointer to another CAM slot that's its master).
+       ///< it doesn't have a pointer to another CAM slot that's its master).
   cCamSlot *MasterSlot(void) { return masterSlot ? masterSlot : this; }
        ///< Returns this CAM slot's master slot, or a pointer to itself if it is a
        ///< master slot.
@@ -402,7 +402,7 @@
        ///< call to AddPid()) to Active. A later call to StartDecrypting() will
        ///< send the full list of currently active CA_PMT entries to the CAM.
   virtual void AddChannel(const cChannel *Channel);
-       ///< Adds all PIDs if the given Channel to the current list of PIDs.
+       ///< Adds all PIDs of the given Channel to the current list of PIDs.
        ///< If the source or transponder of the channel are different than
        ///< what was given in a previous call to AddChannel(), any previously
        ///< added PIDs will be cleared.
diff -ruN vdr-2.3.8/config.c vdr-2.3.9/config.c
--- vdr-2.3.8/config.c	2017-05-21 12:25:26.000000000 +0200
+++ vdr-2.3.9/config.c	2018-02-15 15:40:36.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 4.6 2017/05/21 10:25:26 kls Exp $
+ * $Id: config.c 4.8 2018/02/15 14:40:36 kls Exp $
  */
 
 #include "config.h"
@@ -432,6 +432,7 @@
   FoldersInTimerMenu = 1;
   AlwaysSortFoldersFirst = 1;
   DefaultSortModeRec = rsmTime;
+  RecSortingDirection = rsdAscending;
   NumberKeysForChars = 1;
   ColorKey0 = 0;
   ColorKey1 = 1;
@@ -641,7 +642,7 @@
   else if (!strcasecmp(Name, "SVDRPTimeout"))        SVDRPTimeout       = atoi(Value);
   else if (!strcasecmp(Name, "SVDRPPeering"))        SVDRPPeering       = atoi(Value);
   else if (!strcasecmp(Name, "SVDRPHostName"))     { if (*Value) strn0cpy(SVDRPHostName, Value, sizeof(SVDRPHostName)); }
-  else if (!strcasecmp(Name, "SVDRPdefaultHost"))    strn0cpy(SVDRPDefaultHost, Value, sizeof(SVDRPDefaultHost));
+  else if (!strcasecmp(Name, "SVDRPDefaultHost"))    strn0cpy(SVDRPDefaultHost, Value, sizeof(SVDRPDefaultHost));
   else if (!strcasecmp(Name, "ZapTimeout"))          ZapTimeout         = atoi(Value);
   else if (!strcasecmp(Name, "ChannelEntryTimeout")) ChannelEntryTimeout= atoi(Value);
   else if (!strcasecmp(Name, "RcRepeatDelay"))       RcRepeatDelay      = atoi(Value);
@@ -658,6 +659,7 @@
   else if (!strcasecmp(Name, "RecordingDirs"))       RecordingDirs      = atoi(Value);
   else if (!strcasecmp(Name, "FoldersInTimerMenu"))  FoldersInTimerMenu = atoi(Value);
   else if (!strcasecmp(Name, "AlwaysSortFoldersFirst")) AlwaysSortFoldersFirst = atoi(Value);
+  else if (!strcasecmp(Name, "RecSortingDirection")) RecSortingDirection= atoi(Value);
   else if (!strcasecmp(Name, "DefaultSortModeRec"))  DefaultSortModeRec = atoi(Value);
   else if (!strcasecmp(Name, "NumberKeysForChars"))  NumberKeysForChars = atoi(Value);
   else if (!strcasecmp(Name, "ColorKey0"))           ColorKey0          = atoi(Value);
@@ -789,6 +791,7 @@
   Store("RecordingDirs",      RecordingDirs);
   Store("FoldersInTimerMenu", FoldersInTimerMenu);
   Store("AlwaysSortFoldersFirst", AlwaysSortFoldersFirst);
+  Store("RecSortingDirection",RecSortingDirection);
   Store("DefaultSortModeRec", DefaultSortModeRec);
   Store("NumberKeysForChars", NumberKeysForChars);
   Store("ColorKey0",          ColorKey0);
diff -ruN vdr-2.3.8/config.h vdr-2.3.9/config.h
--- vdr-2.3.8/config.h	2017-06-12 10:58:26.000000000 +0200
+++ vdr-2.3.9/config.h	2017-12-09 15:15:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 4.12 2017/06/12 08:58:26 kls Exp $
+ * $Id: config.h 4.14 2017/12/09 14:15:58 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "2.3.8"
-#define VDRVERSNUM   20308  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "2.3.9"
+#define VDRVERSNUM   20309  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "2.3.8"
-#define APIVERSNUM   20308  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "2.3.9"
+#define APIVERSNUM   20309  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -306,6 +306,7 @@
   int FoldersInTimerMenu;
   int AlwaysSortFoldersFirst;
   int DefaultSortModeRec;
+  int RecSortingDirection;
   int NumberKeysForChars;
   int ColorKey0, ColorKey1, ColorKey2, ColorKey3;
   int VideoDisplayFormat;
diff -ruN vdr-2.3.8/cutter.c vdr-2.3.9/cutter.c
--- vdr-2.3.8/cutter.c	2017-05-21 11:45:06.000000000 +0200
+++ vdr-2.3.9/cutter.c	2018-01-18 13:19:31.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 4.3 2017/05/21 09:45:06 kls Exp $
+ * $Id: cutter.c 4.6 2018/01/18 12:19:31 kls Exp $
  */
 
 #include "cutter.h"
@@ -677,8 +677,6 @@
               cRecordingUserCommand::InvokeCommand(RUC_EDITINGRECORDING, editedVersionName, originalVersionName);
               if (cVideoDirectory::RemoveVideoFile(editedVersionName) && MakeDirs(editedVersionName, true)) {
                  Recording.WriteInfo(editedVersionName);
-                 LOCK_RECORDINGS_WRITE;
-                 Recordings->AddByName(editedVersionName, false);
                  cuttingThread = new cCuttingThread(originalVersionName, editedVersionName);
                  return true;
                  }
@@ -702,9 +700,6 @@
         esyslog("ERROR: '%s' during editing process", Error);
      if (cReplayControl::NowReplaying() && strcmp(cReplayControl::NowReplaying(), editedVersionName) == 0)
         cControl::Shutdown();
-     cVideoDirectory::RemoveVideoFile(editedVersionName);
-     LOCK_RECORDINGS_WRITE;
-     Recordings->DelByName(editedVersionName);
      }
 }
 
diff -ruN vdr-2.3.8/device.c vdr-2.3.9/device.c
--- vdr-2.3.8/device.c	2017-05-30 13:06:11.000000000 +0200
+++ vdr-2.3.9/device.c	2018-01-27 15:45:08.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 4.23 2017/05/30 11:06:11 kls Exp $
+ * $Id: device.c 4.26 2018/01/27 14:45:08 kls Exp $
  */
 
 #include "device.h"
@@ -120,6 +120,7 @@
   delete dvbSubtitleConverter;
   if (this == primaryDevice)
      primaryDevice = NULL;
+  Cancel(3);
 }
 
 bool cDevice::WaitForAllDevicesReady(int Timeout)
@@ -1673,6 +1674,7 @@
                  int Pid = TsPid(b);
                  bool IsScrambled = TsIsScrambled(b);
                  for (int i = 0; i < MAXRECEIVERS; i++) {
+                     cMutexLock MutexLock(&mutexReceiver);
                      cReceiver *Receiver = receiver[i];
                      if (Receiver && Receiver->WantsPid(Pid)) {
                         Receiver->Receive(b, TS_SIZE);
@@ -1768,10 +1770,8 @@
                 }
              }
          Receiver->Activate(true);
-         Lock();
          Receiver->device = this;
          receiver[i] = Receiver;
-         Unlock();
          if (camSlot && Receiver->priority > MINPRIORITY) { // priority check to avoid an infinite loop with the CAM slot's caPidReceiver
             camSlot->StartDecrypting();
             if (camSlot->WantsTsData()) {
@@ -1801,13 +1801,11 @@
   if (!Receiver || Receiver->device != this)
      return;
   bool receiversLeft = false;
-  cMutexLock MutexLock(&mutexReceiver);
+  mutexReceiver.Lock();
   for (int i = 0; i < MAXRECEIVERS; i++) {
       if (receiver[i] == Receiver) {
-         Lock();
          receiver[i] = NULL;
          Receiver->device = NULL;
-         Unlock();
          Receiver->Activate(false);
          for (int n = 0; n < Receiver->numPids; n++)
              DelPid(Receiver->pids[n]);
@@ -1815,6 +1813,7 @@
       else if (receiver[i])
          receiversLeft = true;
       }
+  mutexReceiver.Unlock();
   if (camSlot) {
      if (Receiver->priority > MINPRIORITY) { // priority check to avoid an infinite loop with the CAM slot's caPidReceiver
         camSlot->StartDecrypting();
diff -ruN vdr-2.3.8/device.h vdr-2.3.9/device.h
--- vdr-2.3.8/device.h	2017-05-30 13:06:11.000000000 +0200
+++ vdr-2.3.9/device.h	2017-11-02 15:47:33.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 4.10 2017/05/30 11:06:11 kls Exp $
+ * $Id: device.h 4.12 2017/11/02 14:47:33 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -55,13 +55,6 @@
                  // KNOWN TO YOUR PLAYER.
                };
 
-//#define DEPRECATED_VIDEOSYSTEM
-#ifdef DEPRECATED_VIDEOSYSTEM
-enum eVideoSystem { vsPAL,
-                    vsNTSC
-                  };
-#endif
-
 enum eVideoDisplayFormat { vdfPanAndScan,
                            vdfLetterBox,
                            vdfCenterCutOut
@@ -356,8 +349,10 @@
 public:
   static int CurrentChannel(void) { return primaryDevice ? currentChannel : 0; }
          ///< Returns the number of the current channel on the primary device.
-#define DEPRECATED_SETCURRENTCHANNEL
-#ifdef DEPRECATED_SETCURRENTCHANNEL
+#ifndef DEPRECATED_SETCURRENTCHANNEL
+#define DEPRECATED_SETCURRENTCHANNEL 1
+#endif
+#if DEPRECATED_SETCURRENTCHANNEL
   static void SetCurrentChannel(const cChannel *Channel) { currentChannel = Channel ? Channel->Number() : 0; }
 #endif
   static void SetCurrentChannel(int ChannelNumber) { currentChannel = ChannelNumber; }
@@ -510,12 +505,6 @@
          ///< if this device has an MPEG decoder).
          ///< NOTE: this is only for SD devices. HD devices shall implement their
          ///< own setup menu with the necessary parameters for controlling output.
-#ifdef DEPRECATED_VIDEOSYSTEM
-  virtual eVideoSystem GetVideoSystem(void) { return vsPAL; }
-         ///< Returns the video system of the currently displayed material
-         ///< (default is PAL).
-         ///< This function is deprecated and will be removed in a future version!
-#endif
   virtual void GetVideoSize(int &Width, int &Height, double &VideoAspect);
          ///< Returns the Width, Height and VideoAspect ratio of the currently
          ///< displayed video material. Width and Height are given in pixel
diff -ruN vdr-2.3.8/dvbdevice.c vdr-2.3.9/dvbdevice.c
--- vdr-2.3.8/dvbdevice.c	2017-05-09 13:50:38.000000000 +0200
+++ vdr-2.3.9/dvbdevice.c	2018-02-15 16:37:01.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 4.13 2017/05/09 11:50:38 kls Exp $
+ * $Id: dvbdevice.c 4.16 2018/02/15 15:37:01 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -699,6 +699,231 @@
   return 100 - v * v;
 }
 
+#define REF_S1(q1)                 (mod == QPSK)   ? q1 : 0
+#define REF_S2(q1, q2, q3, q4)     (mod == QPSK)   ? q1 : (mod == PSK_8)  ? q2 : (mod == APSK_16) ? q3 : (mod == APSK_32) ? q4 : 0
+#define REF_T1(q1, q2, q3)         (mod == QPSK)   ? q1 : (mod == QAM_16) ? q2 : (mod == QAM_64)  ? q3 : 0
+#define REF_T2(q1, q2, q3, q4)     (mod == QPSK)   ? q1 : (mod == QAM_16) ? q2 : (mod == QAM_64)  ? q3 : (mod == QAM_256) ? q4 : 0
+#define REF_C1(q1, q2, q3, q4, q5) (mod == QAM_16) ? q1 : (mod == QAM_32) ? q2 : (mod == QAM_64)  ? q3 : (mod == QAM_128) ? q4 : (mod == QAM_256) ? q5: 0
+
+int StrengthToSSI(const cChannel *Channel, int Strength, int FeModulation, int FeCoderateH, int FeFec)
+{
+  // Strength in 0.001dBm (dBm x 1000)
+  cDvbTransponderParameters dtp(Channel->Parameters());
+  int ssi = 0; // 0-100
+  int mod = (FeModulation >= 0) ? FeModulation : dtp.Modulation();
+  int cod = (FeCoderateH >= 0) ? FeCoderateH : dtp.CoderateH(); // DVB-T
+  int fec = (FeFec >= 0) ? FeFec : dtp.CoderateH();
+  if (Channel->IsTerr()) {
+     int pref = 0;
+     // NorDig Unified Ver. 2.6 - 3.4.4.6 Page 43 ff.
+     // reference values : pref-15dBm = 0%, pref+35dBm = 100%
+     if (dtp.System() == DVB_SYSTEM_1) { // DVB-T
+        fec = cod; // adjustment for DVB-T
+        if (mod == QAM_AUTO) mod = QPSK;
+        switch (fec) {  // dBm:        Q4  Q16  Q64
+          case FEC_1_2: pref = REF_T1(-93, -87, -82); break;
+          default:
+          case FEC_2_3: pref = REF_T1(-91, -85, -80); break;
+          case FEC_3_4: pref = REF_T1(-90, -84, -78); break;
+          case FEC_5_6: pref = REF_T1(-89, -83, -77); break;
+          case FEC_7_8: pref = REF_T1(-88, -82, -76); break;
+          }
+        }
+     else { // DVB-T2
+        if (mod == QAM_AUTO) mod = QAM_64;
+        switch (fec) {  // dBm:        Q4  Q16  Q64 Q256
+          case FEC_1_2: pref = REF_T2(-96, -91, -86, -82); break;
+          default:
+          case FEC_3_5: pref = REF_T2(-95, -89, -85, -80); break;
+          case FEC_2_3: pref = REF_T2(-94, -88, -83, -78); break;
+          case FEC_3_4: pref = REF_T2(-93, -87, -82, -76); break;
+          case FEC_4_5: pref = REF_T2(-92, -86, -81, -75); break;
+          case FEC_5_6: pref = REF_T2(-92, -86, -80, -74); break;
+          }
+        }
+     if (pref) {
+        int prel = (Strength / 1000) - pref;
+        ssi = (prel < -15) ? 0 :
+              (prel <   0) ? (prel + 15) * 2 / 3 :       //  0% -  10%
+              (prel <  20) ? prel * 4 + 10 :             // 10% -  90%
+              (prel <  35) ? (prel - 20) * 2 / 3 + 90 :  // 90% - 100%
+              100;
+#ifdef DEBUG_SIGNALSTRENGTH
+        fprintf(stderr, "SSI-T: STR:%d, Pref:%d, Prel:%d, ssi:%d%%(sys:%d, mod:%d, fec:%d)\n", Strength, pref, prel, ssi, dtp.System(), mod, fec);
+#endif
+        }
+     }
+  else if (Channel->IsCable()) { // ! COMPLETELY UNTESTED !
+     // Formula: pref(dB) = -174.0 + NoiseFigure + SymRef + CnRef
+     // NoiseFigure = 6.5 dB;               -> Tuner specific - range: 3.5 .. 9.0 dB
+     // SymRef = 10*log(6900000) = 68.5 dB; -> for Symbolrate of 6900 kSym/sec (TV: 6900, 6750 or 6111 kSym/sec)
+     // ==> pref(dB) = -174.0 + 6.5 + 68.5 + CnRef[modulation]{20,23,26,29,32}; (+/- 3 dB tuner specific)
+     if (mod == QAM_AUTO) mod = QAM_256;
+     //                Q16  Q32  Q64 Q128 Q256
+     int pref = REF_C1(-79, -76, -73, -70, -67);
+     if (pref) {
+        int prel = (Strength / 1000) - pref;
+        ssi = (prel < -15) ? 0 :
+              (prel <   0) ? (prel + 15) * 2 / 3 :       //  0% -  10%
+              (prel <  20) ? prel * 4 + 10 :             // 10% -  90%
+              (prel <  35) ? (prel - 20) * 2 / 3 + 90 :  // 90% - 100%
+              100;
+#ifdef DEBUG_SIGNALSTRENGTH
+        fprintf(stderr, "SSI-C: STR:%d, Pref:%d, Prel:%d, ssi:%d%%(mod:%d)\n", Strength, pref, prel, ssi, mod);
+#endif
+        }
+     }
+  else if (Channel->IsSat())
+     ssi = dB1000toPercent(Strength, -95000, -20000); // defaults
+  return ssi;
+}
+
+// Due to missing values or the different meanings of the reported error rate, ber_sqi is currently not taken into account
+#define IGNORE_BER 1
+#define BER_ERROR_FREE (1000*1000*1000) // 1/10^-9
+
+int SignalToSQI(const cChannel *Channel, int Signal, int Ber, int FeModulation, int FeCoderateH, int FeFec)
+{
+#if IGNORE_BER
+  Ber = BER_ERROR_FREE; // assume/pretend to be biterror free
+#endif
+  // Signal in 0.001dB (dB x 1000)
+  cDvbTransponderParameters dtp(Channel->Parameters());
+  int sqi = 0; // 0-100
+  int mod = (FeModulation >= 0) ? FeModulation : dtp.Modulation();
+  int cod = (FeCoderateH >= 0) ? FeCoderateH : dtp.CoderateH(); // DVB-T
+  int fec = (FeFec >= 0) ? FeFec : dtp.CoderateH();
+  if (Channel->IsTerr()) { // QEF: BER 10^-6
+     int cnref = 0;
+     // NorDig Unified Ver. 2.6 - 3.4.4.7 Page 45 ff.
+     // reference values for QEF (BER 10^-11 at MPEG2 demux input)
+     if (dtp.System() == DVB_SYSTEM_1) { // DVB-T
+        fec = cod; // adjustment for DVB-T
+        if (mod == QAM_AUTO) mod = QPSK;
+        switch (fec) {  // 0.1 dB      Q4  Q16  Q64 (Hierarchy=None)
+          case FEC_1_2: cnref = REF_T1(51, 108, 165); break;
+          default:
+          case FEC_2_3: cnref = REF_T1(69, 131, 187); break;
+          case FEC_3_4: cnref = REF_T1(79, 146, 202); break;
+          case FEC_5_6: cnref = REF_T1(89, 156, 216); break;
+          case FEC_7_8: cnref = REF_T1(97, 160, 225); break;
+          }
+        }
+     else { // DVB-T2
+        if (mod == QAM_AUTO) mod = QAM_64;
+        switch (fec) {  // 0.1 dB      Q4  Q16  Q64 Q256
+          case FEC_1_2: cnref = REF_T2(35,  87, 130, 170); break;
+          default:
+          case FEC_3_5: cnref = REF_T2(47, 101, 148, 194); break;
+          case FEC_2_3: cnref = REF_T2(56, 114, 162, 208); break;
+          case FEC_3_4: cnref = REF_T2(66, 125, 177, 229); break;
+          case FEC_4_5: cnref = REF_T2(72, 133, 187, 243); break;
+          case FEC_5_6: cnref = REF_T2(77, 138, 194, 251); break;
+          }
+        }
+     if (cnref) {
+        int cnrel = (Signal/100) - cnref; // 0.1 dB
+        int ber_sqi = 100; // 100%
+        int cnr_sqi = 0;   // 0%
+        if (dtp.System() == DVB_SYSTEM_1) { // DVB-T
+            ber_sqi = (Ber < 1000) ? 0 :           // > 10^-3
+                      (Ber >= 10000000) ? 100 :    // <= 10^-7
+                      (int)(20 * log10(Ber)) - 40; // 20*log10(1/BER)-40 -> 20% .. 100%
+            // scale: -7dB/+3dB to reference-value
+            cnr_sqi = (cnrel < -70) ? 0 :
+                      (cnrel < +30) ? (100 + (cnrel - 30)) :
+                      100;
+            sqi = (cnr_sqi * ber_sqi) / 100;
+            // alternative: stretched scale: cnref-7dB = 0%, 30dB = 100%
+            // sqi = dB1000toPercent(Signal, (100*cnref)-7000, 30000);
+            }
+        else { // DVB-T2
+            ber_sqi = (Ber < 10000)     ? 0 :             // > 10^-4
+                      (Ber >= 10000000) ? 100 * 100 / 6 : // <= 10^-7 : 16.67% -> SQI 0% .. 100%
+                      (100 * 100 / 15);                   //             6.67% -> SQI 0% .. 40% || 100%
+            // scale: -3dB/+3dB to reference-value
+            sqi = (cnrel <  -30) ? 0 :
+                  (cnrel <= +30) ? (cnrel + 30) * ber_sqi / 1000 : // (0 .. 6) * 16,67 || 6.67
+                  100;
+            // alternative: stretched scale: cnref-3dB = 0%, 32dB = 100%
+            // sqi = dB1000toPercent(Signal, (100*cnref)-3000, 32000);
+            }
+#ifdef DEBUG_SIGNALQUALITY
+        fprintf(stderr, "SQI-T: SIG:%d, BER:%d, CNref:%d, CNrel:%d, bersqi:%d, sqi:%d%%(sys:%d, mod:%d, fec:%d)\n", Signal, Ber, cnref, cnrel, ber_sqi, sqi, dtp.System(), mod, fec);
+#endif
+        }
+     }
+  else if (Channel->IsCable()) { // ! COMPLETELY UNTESTED !
+     if (mod == QAM_AUTO) mod = QAM_256;
+         // 0.1 dB      Q16  Q32  Q64 Q128 Q256
+     int cnref = REF_C1(200, 230, 260, 290, 320); // minimum for BER<10^-4
+     if (cnref) {
+        int cnrel = (Signal / 100) - cnref; // 0.1 dB
+        int ber_sqi = (Ber < 1000)      ? 0 :      // > 10^-3
+                      (Ber >= 10000000) ? 100 :    // <= 10^-7
+                      (int)(20 * log10(Ber)) - 40; // 20*log10(1/BER)-40 -> 20% .. 100%
+        // scale: -7dB/+3dB to reference-value
+        int cnr_sqi = (cnrel < -70) ? 0 :
+                      (cnrel < +30) ? (100 + (cnrel - 30)) :
+                      100;
+        sqi = (cnr_sqi * ber_sqi) / 100;
+        // alternative: stretched scale: cnref-7dB = 0%, 40dB = 100%
+        // sqi = dB1000toPercent(Signal, (100*cnref)-7000, 40000);
+#ifdef DEBUG_SIGNALQUALITY
+        dsyslog("SQI-C: SIG:%d, BER:%d, CNref:%d, CNrel:%d, bersqi:%d, sqi:%d%%(sys:%d, mod:%d, fec:%d)\n", Signal, Ber, cnref, cnrel, ber_sqi, sqi, dtp.System(), mod, fec);
+#endif
+        }
+     }
+  else if (Channel->IsSat()) {
+    int cnref = 0;
+    if (dtp.System() == DVB_SYSTEM_1) { // DVB-S
+        if (mod == QAM_AUTO) mod = QPSK;
+        switch (fec) {  // 0.1 dB:     Q4 : 10^-7
+          case FEC_1_2: cnref = REF_S1(38); break;
+          default:
+          case FEC_2_3: cnref = REF_S1(56); break;
+          case FEC_3_4: cnref = REF_S1(67); break;
+          case FEC_5_6: cnref = REF_S1(77); break;
+          case FEC_7_8: cnref = REF_S1(84); break;
+          }
+        if (cnref) {
+           //cnrel = (Signal/100) - cnref; // 0.1 dB
+           // scale: cnref-4dB = 0%, 15dB = 100%
+           sqi = dB1000toPercent(Signal, (100*cnref)-4000, 15000);
+#ifdef DEBUG_SIGNALQUALITY
+           dsyslog("SQI-S1: SIG:%d, BER:%d, CNref:%d, sqi:%d%%(mod:%d, fec:%d)\n", Signal, Ber, cnref, sqi, mod, fec);
+#endif
+           }
+        }
+    else { // DVB-S2
+        if (mod == QAM_AUTO) mod = QAM_64;
+        switch (fec) {   // 0.1 dB       Q4   Q8 16A* 32A*
+        //case FEC_1_4:  cnref = REF_S2(-14,  65,  90, 126); break;
+        //case FEC_1_3:  cnref = REF_S2( -2,  65,  90, 126); break;
+          case FEC_2_5:  cnref = REF_S2(  7,  65,  90, 126); break;
+          case FEC_1_2:  cnref = REF_S2( 20,  65,  90, 126); break;
+          case FEC_3_5:  cnref = REF_S2( 32,  65,  90, 126); break;
+          default:
+          case FEC_2_3:  cnref = REF_S2( 41,  76,  90, 126); break;
+          case FEC_3_4:  cnref = REF_S2( 50,  66, 102, 126); break;
+          case FEC_4_5:  cnref = REF_S2( 57,  89, 110, 136); break;
+          case FEC_5_6:  cnref = REF_S2( 62, 104, 116, 143); break;
+          case FEC_8_9:  cnref = REF_S2( 72, 117, 129, 157); break;
+          case FEC_9_10: cnref = REF_S2( 74, 120, 131, 161); break;
+          }
+        if (cnref) {
+           // cnrel = (Signal/100) - cnref; // 0.1 dB
+           // scale: cnref-4dB = 0%, 20dB = 100%
+           sqi = dB1000toPercent(Signal, (100*cnref)-4000, 20000);
+#ifdef DEBUG_SIGNALQUALITY
+           dsyslog("SQI-S2: SIG:%d, BER:%d, CNref:%d, sqi:%d%%(mod:%d, fec:%d)\n", Signal, Ber, cnref, sqi, mod, fec);
+#endif
+           }
+        }
+  }
+  return sqi;
+}
+
 int cDvbTuner::GetSignalStrength(void) const
 {
   ClearEventQueue();
@@ -710,14 +935,20 @@
       memset(&CmdSeq, 0, sizeof(CmdSeq));
       CmdSeq.props = Props;
       SETCMD(DTV_STAT_SIGNAL_STRENGTH, 0);
+      SETCMD(DTV_MODULATION, 0);
+      SETCMD(DTV_CODE_RATE_HP, 0); // DVB-T only
+      SETCMD(DTV_INNER_FEC, 0);
       if (ioctl(fd_frontend, FE_GET_PROPERTY, &CmdSeq) != 0) {
          esyslog("ERROR: frontend %d/%d: %m", adapter, frontend);
          return -1;
          }
-      int Signal = 0;;
+      int FeMod = (Props[1].u.st.len > 0) ? (int)Props[1].u.data : -1;
+      int FeCod = (Props[2].u.st.len > 0) ? (int)Props[2].u.data : -1;
+      int FeFec = (Props[3].u.st.len > 0) ? (int)Props[3].u.data : -1;
+      int Signal = 0;
       if (Props[0].u.st.len > 0) {
          switch (Props[0].u.st.stat[0].scale) {
-           case FE_SCALE_DECIBEL:  Signal = dB1000toPercent(Props[0].u.st.stat[0].svalue, -95000, -20000); // TODO use different values for DVB-S, -T, -C?
+           case FE_SCALE_DECIBEL:  Signal = StrengthToSSI(&channel, Props[0].u.st.stat[0].svalue, FeMod, FeCod, FeFec);
                                    break;
            case FE_SCALE_RELATIVE: Signal = 100 * Props[0].u.st.stat[0].uvalue / 0xFFFF;
                                    break;
@@ -768,14 +999,32 @@
       memset(&CmdSeq, 0, sizeof(CmdSeq));
       CmdSeq.props = Props;
       SETCMD(DTV_STAT_CNR, 0);
+      SETCMD(DTV_MODULATION, 0);
+      SETCMD(DTV_CODE_RATE_HP, 0); // DVB-T only
+      SETCMD(DTV_INNER_FEC, 0);
+      SETCMD(DTV_STAT_POST_ERROR_BIT_COUNT, 0);
+      SETCMD(DTV_STAT_POST_TOTAL_BIT_COUNT, 0);
       if (ioctl(fd_frontend, FE_GET_PROPERTY, &CmdSeq) != 0) {
          esyslog("ERROR: frontend %d/%d: %m", adapter, frontend);
          return -1;
          }
-      int Cnr = 0;;
+      int FeMod = (Props[1].u.st.len > 0) ? (int)Props[1].u.data : -1;
+      int FeCod = (Props[2].u.st.len > 0) ? (int)Props[2].u.data : -1;
+      int FeFec = (Props[3].u.st.len > 0) ? (int)Props[3].u.data : -1;
+      int Ber = BER_ERROR_FREE; // 1/10^-9
+      if (Props[4].u.st.len > 0 && Props[4].u.st.stat[0].scale == FE_SCALE_COUNTER && Props[5].u.st.len > 0 && Props[5].u.st.stat[0].scale == FE_SCALE_COUNTER) {
+         uint64_t ebc = Props[4].u.st.stat[0].uvalue; // error bit count
+         uint64_t tbc = Props[5].u.st.stat[0].uvalue; // total bit count
+         if (ebc > 0) {
+            uint64_t BerRev = tbc / ebc; // reversed, for integer arithmetic
+            if (BerRev < BER_ERROR_FREE)
+               Ber = (int)BerRev;
+            }
+         }
+      int Cnr = 0;
       if (Props[0].u.st.len > 0) {
          switch (Props[0].u.st.stat[0].scale) {
-           case FE_SCALE_DECIBEL:  Cnr = dB1000toPercent(Props[0].u.st.stat[0].svalue, 5000, 20000); // TODO use different values for DVB-S, -T, -C?
+           case FE_SCALE_DECIBEL:  Cnr = SignalToSQI(&channel, Props[0].u.st.stat[0].svalue, Ber, FeMod, FeCod, FeFec);
                                    break;
            case FE_SCALE_RELATIVE: Cnr = 100 * Props[0].u.st.stat[0].uvalue / 0xFFFF;
                                    break;
@@ -1116,13 +1365,13 @@
      SETCMD(DTV_HIERARCHY, dtp.Hierarchy());
      if (frontendType == SYS_DVBT2) {
         // DVB-T2
+        SETCMD(DTV_INNER_FEC, dtp.CoderateH());
         if (DvbApiVersion >= 0x0508) {
            SETCMD(DTV_STREAM_ID, dtp.StreamId());
            }
         else if (DvbApiVersion >= 0x0503)
            SETCMD(DTV_DVBT2_PLP_ID_LEGACY, dtp.StreamId());
         }
-
      tuneTimeout = DVBT_TUNE_TIMEOUT;
      lockTimeout = DVBT_LOCK_TIMEOUT;
      }
diff -ruN vdr-2.3.8/dvbplayer.c vdr-2.3.9/dvbplayer.c
--- vdr-2.3.8/dvbplayer.c	2016-12-22 12:34:31.000000000 +0100
+++ vdr-2.3.9/dvbplayer.c	2017-11-26 15:55:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 4.4 2016/12/22 11:34:31 kls Exp $
+ * $Id: dvbplayer.c 4.5 2017/11/26 14:55:03 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -1003,6 +1003,7 @@
 
 void cDvbPlayerControl::Stop(void)
 {
+  cControl::player = NULL;
   delete player;
   player = NULL;
 }
diff -ruN vdr-2.3.8/eit.c vdr-2.3.9/eit.c
--- vdr-2.3.8/eit.c	2017-05-03 10:58:41.000000000 +0200
+++ vdr-2.3.9/eit.c	2017-10-11 11:19:42.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 4.3 2017/05/03 08:58:41 kls Exp $
+ * $Id: eit.c 4.4 2017/10/11 09:19:42 kls Exp $
  */
 
 #include "eit.h"
@@ -94,10 +94,10 @@
       // Drop bogus events - but keep NVOD reference events, where all bits of the start time field are set to 1, resulting in a negative number.
       if (StartTime == 0 || StartTime > 0 && Duration == 0)
          continue;
+      Empty = false;
       // Ignore events that ended before the "EPG linger time":
       if (StartTime + Duration < LingerLimit)
          continue;
-      Empty = false;
       if (!SegmentStart)
          SegmentStart = StartTime;
       SegmentEnd = StartTime + Duration;
